Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_B.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_B.gif
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_B.gif	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_B.gif	(revision 589)

Property changes on: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_B.gif
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_R.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_R.gif
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_R.gif	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_R.gif	(revision 589)

Property changes on: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_R.gif
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbca_dim.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbca_dim.gif
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbca_dim.gif	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbca_dim.gif	(revision 589)

Property changes on: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbca_dim.gif
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbcc_dim.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbcc_dim.gif
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbcc_dim.gif	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbcc_dim.gif	(revision 589)

Property changes on: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/led_rgbcc_dim.gif
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_G.gif
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_G.gif
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_G.gif	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_G.gif	(revision 589)

Property changes on: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_G.gif
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGBd_on.jpg
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGBd_on.jpg
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGBd_on.jpg	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGBd_on.jpg	(revision 589)

Property changes on: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGBd_on.jpg
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_pat.jpg
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_pat.jpg
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_pat.jpg	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_pat.jpg	(revision 589)

Property changes on: trunk/hardware/auto recharge/Charging Station/new/TriColor LED_files/RGB_pat.jpg
___________________________________________________________________
Added: svn:mime-type
## -0,0 +1 ##
+application/octet-stream
\ No newline at end of property
Index: trunk/hardware/auto recharge/Charging Station/new/TriColor LED.htm
===================================================================
--- trunk/hardware/auto recharge/Charging Station/new/TriColor LED.htm	(nonexistent)
+++ trunk/hardware/auto recharge/Charging Station/new/TriColor LED.htm	(revision 589)
@@ -0,0 +1,139 @@
+<html><head><title>TriColor RGB LED</title>
+
+
+<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
+<style type="text/css">
+<!--
+.style2 {font-size: 8pt}
+-->
+</style></head><body bgcolor="#ffffff" link="#999999" text="#000000" vlink="#cccccc">
+<div align="center"><font face="Arial, Helvetica, sans-serif"><b><font size="5">TriColor 
+<font color="#ff0000">RED</font> <font color="#00ff00">GREEN</font> <font color="#0000f0">BLUE</font> 
+LED<br> <br> </font></b></font> <table bordercolorlight="#000000" bordercolordark="#000000" border="0" bordercolor="#000000" width="80%"> 
+<tbody><tr> <td><font face="Arial, Helvetica, sans-serif"><font size="3"><b><font color="#000000">This 
+full color super bright LED contains red green and blue LEDS housed in a single 
+5mm epoxy package They are available with water clear or milky white diffused 
+lenses as part numbers RL5-RGB-C and RL5-RGB-D &nbsp;&nbsp;&nbsp;&nbsp;<font color="#333333">Available 
+with common CATHODE or ANODE</font></font></b></font></font></td></tr> </tbody></table><font face="Arial, Helvetica, sans-serif"><b><font size="5"> 
+<font size="-1"><a href="http://www.superbrightleds.com/cgi-bin/store/commerce.cgi?product=LEDS"><font size="3">CLICK 
+HERE TO BUY ONLINE NOW</font></a></font><br></font></b></font>
+<table bordercolorlight="#000000" bordercolordark="#000000" border="0" bordercolor="#000000" width="80%">
+  <tbody><tr>
+    <td><p align="center"><font face="Arial, Helvetica, sans-serif"><font size="3"><b><font color="#000000">We also offer an automatic color changing RGB LED.<br>
+                <a href="http://www.superbrightleds.com/specs/rgb-acc-spec.htm">CLICK HERE TO SEE SPECS
+                </a> </font></b></font></font></p>      </td>
+  </tr>
+</tbody></table>
+<font face="Arial, Helvetica, sans-serif"><b><font size="5"><br> 
+</font></b></font> 
+<table bordercolorlight="#999999" bordercolordark="#666666" bgcolor="#ffffff" border="1" width="80%"> 
+<tbody><tr> <td colspan="6" height="22"><font color="#ff0000">optoelectric characteristics: 
+SUPER RED (AlGalpn)</font></td></tr> <tr> <th width="30%"><font color="#ff0000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>PARAMETER</b></font></th><th width="13%"> 
+<div align="center"><font color="#ff0000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>SYMBOL</b></font></div></th><th width="10%"> 
+<div align="center"><font color="#ff0000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>MAX</b></font></div></th><th width="11%"> 
+<div align="center"><font color="#ff0000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>TYP</b></font></div></th><th width="15%"> 
+<div align="center"><font color="#ff0000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>UNIT</b></font></div></th><th width="21%"><font color="#ff0000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>TEST</b></font></th></tr> 
+<tr> <td width="30%"><font color="#ff0000" size="-1">View Angle of Half Power</font></td><td width="13%"> 
+<div align="center"><font color="#ff0000">2ø1/2</font></div></td><td width="10%"><font color="#ff0000"></font> 
+</td><td width="11%"> <div align="center">15</div></td><td width="15%"> <div align="center"><font color="#ff0000">Degree</font></div></td><td width="21%"><font color="#ff0000"></font></td></tr> 
+<tr> <td width="30%"><font color="#ff0000" size="-1">Forward Voltage</font></td><td width="13%"> 
+<div align="center"><font color="#ff0000">VF</font></div></td><td width="10%"> 
+<div align="center">2.6</div></td><td width="11%"> <div align="center">2.0</div></td><td width="15%"> 
+<div align="center"><font color="#ff0000">V</font></div></td><td width="21%"><font color="#ff0000">IF=20mA</font></td></tr> 
+<tr> <td height="22" width="30%"><font color="#ff0000" size="-1">Peak Emission 
+Wavelength</font></td><td height="22" width="13%"> <div align="center"><font color="#ff0000">ÿ 
+P</font></div></td><td height="22" width="10%"><font color="#ff0000"></font> </td><td height="22" width="11%"> 
+<div align="center">630</div></td><td height="22" width="15%"> <div align="center"><font color="#ff0000">nm</font></div></td><td height="22" width="21%"><font color="#ff0000"></font></td></tr> 
+<tr> <td width="30%"><font color="#ff0000">Luminous Intensity</font></td><td width="13%"> 
+<div align="center"><font color="#ff0000">IV</font></div></td><td width="10%"><font color="#ff0000"></font> 
+</td><td width="11%"> <div align="center">1200</div></td><td width="15%"> <div align="center"><font color="#ff0000">mcd</font></div></td><td width="21%"><font color="#ff0000">IF=20mA</font></td></tr><tr><td colspan="6"><div align="center"><img src="TriColor%20LED_files/RGB_R.gif" height="187" width="750"></div></td></tr> 
+</tbody></table><br> <table bordercolorlight="#999999" bordercolordark="#666666" bgcolor="#ffffff" border="1" width="80%"> 
+<tbody><tr> <td colspan="6" height="22"><font color="#00ff00"><b>optoelectric characteristics: 
+SUPER GREEN (GaInN/GaN)</b></font></td></tr> <tr> <th width="30%"><font color="#00ff00"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="-1">PARAMETER</font></b></font></th><th width="13%"> 
+<div align="center"><font color="#00ff00"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="-1">SYMBOL</font></b></font></div></th><th width="10%"> 
+<div align="center"><font color="#00ff00"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="-1">MAX</font></b></font></div></th><th width="11%"> 
+<div align="center"><font color="#00ff00"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="-1">TYP</font></b></font></div></th><th width="15%"> 
+<div align="center"><font color="#00ff00"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="-1">UNIT</font></b></font></div></th><th width="21%"><font color="#00ff00"><b><font face="Verdana, Arial, Helvetica, sans-serif" size="-1">TEST</font></b></font></th></tr> 
+<tr> <td width="30%"><font color="#00ff00"><b><font size="-1">View Angle of Half 
+Power</font></b></font></td><td width="13%"> <div align="center"><font color="#00ff00"><b>2ø1/2</b></font></div></td><td width="10%"><font color="#00ff00"><b> 
+</b></font></td><td width="11%"> <div align="center">15</div></td><td width="15%"> 
+<div align="center"><font color="#00ff00"><b>Degree</b></font></div></td><td width="21%"><font color="#00ff00"><b></b></font></td></tr> 
+<tr> <td width="30%"><font color="#00ff00"><b><font size="-1">Forward Voltage</font></b></font></td><td width="13%"> 
+<div align="center"><font color="#00ff00"><b>VF</b></font></div></td><td width="10%"> 
+<div align="center">4.0</div></td><td width="11%"> <div align="center">3.5</div></td><td width="15%"> 
+<div align="center"><font color="#00ff00"><b>V</b></font></div></td><td width="21%"><font color="#00ff00"><b>IF=20mA</b></font></td></tr> 
+<tr> <td height="22" width="30%"><font color="#00ff00"><b><font size="-1">Peak 
+Emission Wavelength</font></b></font></td><td height="22" width="13%"> <div align="center"><font color="#00ff00"><b>ÿ 
+P</b></font></div></td><td height="22" width="10%"><font color="#00ff00"><b> </b></font></td><td height="22" width="11%"> 
+<div align="center">525</div></td><td height="22" width="15%"> <div align="center"><font color="#00ff00"><b>nm</b></font></div></td><td height="22" width="21%"><font color="#00ff00"><b></b></font></td></tr> 
+<tr> <td width="30%"><font color="#00ff00"><b>Luminous Intensity</b></font></td><td width="13%"> 
+<div align="center"><font color="#00ff00"><b>IV</b></font></div></td><td width="10%"><font color="#00ff00"><b> 
+</b></font></td><td width="11%"> <div align="center">3700</div></td><td width="15%"> 
+<div align="center"><font color="#00ff00"><b>mcd</b></font></div></td><td width="21%"><font color="#00ff00"><b>IF=20mA</b></font></td></tr><tr><td colspan="6"><div align="center"><img src="TriColor%20LED_files/RGB_G.gif" height="165" width="750"></div></td></tr> 
+</tbody></table><font face="Arial, Helvetica, sans-serif"><b><font size="5"><br> </font></b></font> 
+<table bordercolorlight="#999999" bordercolordark="#666666" bgcolor="#ffffff" border="1" width="80%"> 
+<tbody><tr> <td colspan="6" height="22"><font color="#0000ff">optoelectric characteristics: 
+SUPER BLUE (GaN)</font></td></tr> <tr> <th width="30%"><font color="#0000ff" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>PARAMETER</b></font></th><th width="13%"> 
+<div align="center"><font color="#0000ff" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>SYMBOL</b></font></div></th><th width="10%"> 
+<div align="center"><font color="#0000ff" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>MAX</b></font></div></th><th width="11%"> 
+<div align="center"><font color="#0000ff" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>TYP</b></font></div></th><th width="15%"> 
+<div align="center"><font color="#0000ff" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>UNIT</b></font></div></th><th width="21%"><font color="#0000ff" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>TEST</b></font></th></tr> 
+<tr> <td width="30%"><font color="#0000ff" size="-1">View Angle of Half Power</font></td><td width="13%"> 
+<div align="center"><font color="#0000ff">2ø1/2</font></div></td><td width="10%"><font color="#0000ff"></font> 
+</td><td width="11%"> <div align="center">15</div></td><td width="15%"> <div align="center"><font color="#0000ff">Degree</font></div></td><td width="21%"><font color="#0000ff"></font></td></tr> 
+<tr> <td width="30%"><font color="#0000ff" size="-1">Forward Voltage</font></td><td width="13%"> 
+<div align="center"><font color="#0000ff">VF</font></div></td><td width="10%"> 
+<div align="center">4.0</div></td><td width="11%"> <div align="center">3.5</div></td><td width="15%"> 
+<div align="center"><font color="#0000ff">V</font></div></td><td width="21%"><font color="#0000ff">IF=20mA</font></td></tr> 
+<tr> <td height="22" width="30%"><font color="#0000ff" size="-1">Peak Emission 
+Wavelength</font></td><td height="22" width="13%"> <div align="center"><font color="#0000ff">ÿ 
+P</font></div></td><td height="22" width="10%"><font color="#0000ff"></font> </td><td height="22" width="11%"> 
+<div align="center">472</div></td><td height="22" width="15%"> <div align="center"><font color="#0000ff">nm</font></div></td><td height="22" width="21%"><font color="#0000ff"></font></td></tr> 
+<tr> <td width="30%"><font color="#0000ff">Luminous Intensity</font></td><td width="13%"> 
+<div align="center"><font color="#0000ff">IV</font></div></td><td width="10%"><font color="#0000ff"></font> 
+</td><td width="11%"> <div align="center">700</div></td><td width="15%"> <div align="center"><font color="#0000ff">mcd</font></div></td><td width="21%"><font color="#0000ff">IF=20mA</font></td></tr><tr><td colspan="6"><div align="center"><img src="TriColor%20LED_files/RGB_B.gif" height="165" width="750"></div></td></tr> 
+</tbody></table><font face="Arial, Helvetica, sans-serif"><b><font color="#333333">AVAILABLE 
+WITH COMMON CATHODE OR COMMON ANODE</font></b></font><br> <table bordercolorlight="#999999" bordercolordark="#666666" bgcolor="#ffffff" border="1" width="80%"> 
+<tbody><tr> 
+      <td colspan="4"><font color="#000000">absolute maximum ratings: (TA=25°C, 
+        per individual LED)<font face="Arial, Helvetica, sans-serif"> <b>PART 
+        NUMBERS RL5-RGB-C and RL5-RGB-D </b></font></font></td>
+    </tr> <tr> <td width="39%"> 
+<div align="center"><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>PARAMETER</b></font></div></td><td width="23%"> 
+<div align="center"><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>SYMBOL</b></font></div></td><td width="20%"> 
+<div align="center"><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>RATING</b></font></div></td><td width="18%"> 
+<div align="center"><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b>UNIT</b></font></div></td></tr> 
+<tr> <td height="27" width="39%"><font color="#000000">Power Dissipation</font></td><td height="27" width="23%"> 
+<div align="center"><font color="#000000">PD</font></div></td><td height="27" width="20%"> 
+<div align="center"><font color="#000000">100</font></div></td><td height="27" width="18%"> 
+<div align="center"><font color="#000000">mW</font></div></td></tr> <tr> <td height="26" width="39%">Continuous 
+Forward Current</td>
+<td height="26" width="23%"> <div align="center">IF</div></td><td height="26" width="20%"> 
+<div align="center">20</div></td><td height="26" width="18%"> <div align="center">mA</div></td></tr> 
+<tr> <td height="27" width="39%">Peak Forward Current (1/10th duty cycle, 0.1ms pulse width)</td>
+<td height="27" width="23%"> 
+<div align="center">IFM</div></td><td height="27" width="20%"> <div align="center">50</div></td><td height="27" width="18%"> 
+<div align="center">mA</div></td></tr> <tr> <td height="26" width="39%">Reverse 
+Voltage</td><td height="26" width="23%"> <div align="center">VR</div></td><td height="26" width="20%"> 
+<div align="center">5.0</div></td><td height="26" width="18%"> <div align="center">V</div></td></tr> 
+<tr> <td height="27" width="39%">Operating Temperature</td><td height="27" width="23%"> 
+<div align="center">TA</div></td><td height="27" width="20%"> <div align="center">-40~+85</div></td><td height="27" width="18%"> 
+<div align="center">°C</div></td></tr> <tr> <td height="27" width="39%">Storage 
+Temperature</td><td height="27" width="23%"> <div align="center">TSTG</div></td><td height="27" width="20%"> 
+<div align="center">-40~+85</div></td><td height="27" width="18%"> <div align="center">°C</div></td></tr> 
+<tr> <td height="26" width="39%">Reverse Current (VR=5V)</td><td height="26" width="23%"> 
+<div align="center">IR</div></td><td height="26" width="20%"> <div align="center">10</div></td><td height="26" width="18%"> 
+<div align="center">µa</div></td></tr> <tr> <td colspan="4" height="32"> 
+<div align="left">Lead Soldering Temperature (3mm from body) 260C (for 3 seconds)</div></td></tr> 
+<tr> <td colspan="4" height="32"> <div align="center"><p><font face="Arial, Helvetica, sans-serif"><b><font size="5"><font size="-1"><a href="http://www.superbrightleds.com/cgi-bin/store/commerce.cgi?product=LEDS"><font size="3">CLICK 
+HERE FOR PRICING AND TO BUY ONLINE NOW</font></a><br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
+&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 
+<img src="TriColor%20LED_files/led_rgbcc_dim.gif" height="180" width="390"></font></font></b></font></p>
+          <p><img src="TriColor%20LED_files/RGB_pat.jpg" height="150" width="250"><img src="TriColor%20LED_files/led_rgbca_dim.gif" height="180" width="390"><img src="TriColor%20LED_files/RGBd_on.jpg" height="150" width="98"><br>
+            <b><font face="Arial, Helvetica, sans-serif">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br>
+            &nbsp;<font size="2">LEADS ARE 0.48mm x 0.48mm square - LEAD SPACING 
+            IS 1.25mm -&nbsp;&nbsp;LEAD LENGTH IS 24mm to 28mm</font></font></b></p>
+        </div></td></tr> 
+</tbody></table>
+</div>
+</body></html>
\ No newline at end of file